﻿using Assets._Scripts;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BoxScript : MonoBehaviour {
    public PlayerController pc;
    public DoorController dc;
    Animator boxAnim;
    private Interaction interaction;

	// Use this for initialization
	void Start () {
        boxAnim = gameObject.GetComponent<Animator>();
        interaction = new Interaction
        {
            Name = "BoxInteraction",
            Repeatable = false,
            Offer = "Push Box",
            Used = false,
            Work = MoveBox
        };
	}
	
	// Update is called once per frame
	void Update () {
		
	}

    private void OnTriggerEnter(Collider col)
    {
        if (col.gameObject.name == "Player")
        {
            print("Player interact with box");
            pc.OfferInteraction(interaction);
        }
    }

    private void OnTriggerExit(Collider col)
    {
        if(col.gameObject.name == "Player")
        {
            print("Player left box trigger");
            pc.CancelInteractionOffer(interaction);
        }
    }

    public void MoveBox()
    {
        boxAnim.SetBool("moveBox", true);
        dc.BlockDoor();
        //move box
    }
}
