﻿using Assets._Scripts;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;
using Assets.Constants;
using PathFinding;

public class BoyController : MonoBehaviour, HasSituation
{
    public DoorController dc;
    float x, y, z = 0;
    bool moving = false;
    private Situation mySituation;

    private void Awake()
    {
        mySituation = new Assets._Scripts.Situation()
        {
            Action = WalkForward,
            Name = "BoyWalkForward",
            SetOffTime = EventTimers.BoyStartWalkingEvent,
            Fires = true
        };
    }
    // Use this for initialization
    void Start()
    {

    }

    // Update is called once per frame
    void Update()
    {
        if (moving)
        {
            transform.Translate(x * Time.deltaTime, y * Time.deltaTime, z * Time.deltaTime);
        }
    }

    private void OnCollisionEnter(Collision collision)
    {
        if (collision.collider.name == "Glass_door")
        {
            print("Boy dead");
            z = 0;
            dc.BreakDoor();      
        }
    }

    public void WalkForward()
    {
        z = 2;
        moving = true;
    }

    public Situation GetSituation()
    {
        return mySituation;
    }
}
