﻿using Assets._Scripts;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;
using Assets.Constants;
using PathFinding;

public class CatController : MonoBehaviour, HasSituation {

    public float x, y, z = 0;
    private bool moving;
    private Situation mySituation;
    private Interaction interaction;
    public PlayerController pc;
    Animator catAnim;
    public GameObject blood;


    // Use this for initialization
    private void Awake()
    {
        mySituation = new Assets._Scripts.Situation()
        {
            Action = StartMoving,
            Name = "CatStartMoving",
            SetOffTime = EventTimers.CatStartWalkingEvent,
            Fires = true
        };
    }
    void Start () {
        interaction = new Interaction
        {
            Name = "CatInteraction",
            Repeatable = false,
            Offer = "Feed cat",
            Used = false,
            Work = EatFish
        };

        catAnim = gameObject.GetComponent<Animator>();
	}
	
	// Update is called once per frame
	void Update () {
        if (moving)
        {
            transform.Translate(x * Time.deltaTime, y * Time.deltaTime, z * Time.deltaTime);
        }
    }

    public void StartMoving()
    {
        z = 1.5f;
        catAnim.SetBool("catWalk", true);
        moving = true;
    }

    public void StopMoving()
    {
        x = 0;
        y = 0;
        z = 0;
        moving = false;
        catAnim.SetBool("catWalk", false);
        
    }

    public void PickUp()
    {
        moving = false;
        catAnim.SetBool("catWalk", false);
    }

    private void OnCollisionEnter(Collision collision)
    {
        print(collision.collider.name);
        if (collision.collider.name == "Car")
        {
            GenerateGrid.GetInstance().disableClosestNode(new Vector3(-8.35f, 0.8f, 26.5f));
            Instantiate(blood, new Vector3(-5f, -1f, 11f), blood.transform.rotation);
            StopMoving();
        }
    }

    public Situation GetSituation()
    {
        return mySituation;
    }

    private void OnTriggerEnter(Collider col)
    {
        if(col.gameObject.name == "Player")
        {
            print("Player entered cat trigger zone");
            if(pc.item is Fish)
            {
                print("Player can interact with cat");
                pc.OfferInteraction(interaction);
            }
            
        }
    }

    private void OnTriggerExit(Collider col)
    {
        if(col.gameObject.name == "Player")
        {
            print("Player left cat trigger");
            pc.CancelInteractionOffer(interaction);
        }
    }

    private void EatFish()
    {
        //animatie fish eating
        catAnim.SetBool("eating", true);
        print("Cat eating fishy");
        mySituation.Fires = false;
    }
}
