﻿using Assets._Scripts;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;
using Assets.Constants;

public class DoorController : MonoBehaviour, HasSituation {

    Animator doorAnim;
    public GameObject wholeGlassDoor;
    public GameObject brokenGlassDoor;
    Rigidbody[] brokenGlassPieces;
    private Situation mySituation;


    private void Awake()
    {
        mySituation = new Assets._Scripts.Situation()
         {
             Action = OpenDoor,
             Name = "OpenDoorEvent",
             SetOffTime = EventTimers.DoorStartOpeningEvent,
             Fires = true
         };
    }

	// Use this for initialization
	void Start () {
        doorAnim = gameObject.GetComponent<Animator>();
	}
	
	// Update is called once per frame
	void Update () {
		
	}

    public void OpenDoor()
    {
        doorAnim.SetBool("doorHit", true);
    }

    public void BreakDoor()
    {
        wholeGlassDoor.SetActive(false);

        brokenGlassPieces = brokenGlassDoor.GetComponentsInChildren<Rigidbody>();

        foreach (Rigidbody rb in brokenGlassPieces)
        {
            rb.useGravity = true;
            rb.isKinematic = false;
        }
    }

    public Situation GetSituation()
    {
        return mySituation;
    }

    public void BlockDoor() {
        mySituation.Fires = false;
    }

}
