﻿using Assets._Scripts;
using Player;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EventController : MonoBehaviour {

    float timer = 0.0f;
    public List<HasSituation> Situations;
    public CarController Car;
    public PianoController Piano;
    public BoyController Boy;
    public CatController Cat;
    public DoorController Door;
    public GrandmaController Gma;
    public GirlController Girl;
    public PlayerMovement Player;
    private Queue<Situation> scriptedEvents;

	// Use this for initialization
	void Start () {
        scriptedEvents = new Queue<Situation>();
        EventFactory ef = new EventFactory(this);
        scriptedEvents = ef.CreateEvents();
    }
	
	// Update is called once per frame
	void Update () {
        timer += Time.deltaTime;
        if (scriptedEvents.Count > 0 && timer > scriptedEvents.Peek().SetOffTime)
        {

            Situation currentEvent = scriptedEvents.Dequeue();
            print(currentEvent.Name);
            if (currentEvent.Fires)
            {
                currentEvent.Action.Invoke();
            }
        }
        
	}

}
