﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using PathFinding;
using Assets._Scripts;
using System;
using Assets.Constants;

public class GirlController : MonoBehaviour , HasSituation{

    public CatController cat;
    private NPCMovement movementScript;
    private Situation mySituation;
    private Animator myAnimation;
    private List<GeneratePath> myPaths;
    private Vector3 originalCatPosition;

    // Use this for initialization
    private void Awake()
    {
        mySituation = new Assets._Scripts.Situation()
        {
            Action = StartMoving,
            Fires = true,
            Name = "GirlStartMoving",
            SetOffTime = EventTimers.GirlStartMoving
        };
    }
	void Start () {
        movementScript = GetComponent<NPCMovement>();
        List<GeneratePath> myPaths = new List<GeneratePath>();
        GeneratePath myPath = new GeneratePath(transform.position, cat.transform.position);
        originalCatPosition = cat.transform.position;
        movementScript.Paths.Enqueue(myPath.GetPath());
        movementScript.InitPath(false);
        movementScript.GrantImmortality();
        myAnimation = GetComponent<Animator>();
	}
	
	// Update is called once per frame
	void Update () {
		
	}

    public void StartMoving()
    {
        print("WE START MOVING NAO");
        movementScript.StartMovement();
    }

    public Situation GetSituation()
    {
        return mySituation;
    }

    private void OnTriggerEnter(Collider other)
    {
        if(other.name == cat.name)
        {
            cat.PickUp();

            movementScript.Paths.Enqueue(new PathFinding.GeneratePath(originalCatPosition, new Vector3(-7.91f, 0, 49.32f)).GetPath());
            movementScript.Paths.Enqueue(new GeneratePath(new Vector3(-7.91f, 0, 49.32f), new Vector3(-3.742f, -0.623f, 73.623f)).GetPath());

        }
    }
}
