﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using PathFinding;

public class GameController : MonoBehaviour {

    private GenerateGrid _gg;
    private List<GridTracker> grids;
    List<Node> path;

    public bool DrawNodes = false;
    [Range(0.1f, 5f)]
    public float NodeDistance = 1.5f;

	// Use this for initialization
	void Start () {
        
        _gg = GenerateGrid.GetInstance();
        grids = _gg.Grids;
	}
	
	// Update is called once per frame
	void Update () {
        if (DrawNodes)
        {
            foreach (GridTracker gt in grids)
            {
                foreach (Node n in gt.nodes)
                {
                    Debug.DrawLine(new Vector3(n.posX, 0, n.posZ), new Vector3(n.posX, 2.0f, n.posZ), Color.green);
                    foreach (Line l in n.Connections)
                    {
                        Debug.DrawLine(new Vector3(l.From.posX, 1.0f, l.From.posZ), new Vector3(l.To.posX, 1.0f, l.To.posZ), Color.magenta);
                    }
                }
            }
        }   
	}
}
