﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

namespace Global
{
    public class UIController : MonoBehaviour
    {
        public GameObject panel;
        private float rotation;
        public float Distance = 0.2f;
        private float visibilityDistance = 3;

        private Vector3 startPos;
        // Use this for initialization
        void Start()
        {
            startPos = panel.transform.position;
        }

        // Update is called once per frame
        void Update()
        {
            UpdatePosition();
            UpdateRotation();
            UpdateVisibility();
        }

        private void UpdatePosition()
        {
            float ProjX = Mathf.Sin(rotation * Mathf.Deg2Rad) * Distance;
            float projZ = Mathf.Cos(rotation * Mathf.Deg2Rad) * Distance;
            Vector3 projection = new Vector3(ProjX, 0, projZ);

            panel.transform.position = (startPos + projection);
        }

        private void UpdateRotation()
        {
            Quaternion direction = Quaternion.LookRotation(GameObject.FindGameObjectWithTag("Player").transform.position - transform.parent.transform.position);
            rotation = direction.eulerAngles.y;

            panel.transform.eulerAngles = new Vector3(panel.transform.eulerAngles.x, rotation + 180, panel.transform.eulerAngles.z);
        }

        private void UpdateVisibility()
        {
            float val = (Vector3.Distance(GameObject.FindGameObjectWithTag("Player").transform.position, transform.parent.transform.position) < visibilityDistance) ? 255 : 0;

            Color c = panel.GetComponent<Image>().color;
            c.a = val;
            panel.GetComponent<Image>().color = c;

            foreach(Transform t in panel.transform)
            {
                c = t.GetComponent<Text>().color;
                c.a = val;
                t.GetComponent<Text>().color = c;
            }
        }
    }
}
