﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace PathFinding
{
    public class NPCController : MonoBehaviour
    {
        public GameObject npc;

        private Vector3 start = new Vector3(-4, 0, 55);
        private Vector3 end = new Vector3(-12, 0, 18.5f);
        private List<GameObject> spawnpoints;
        private List<GameObject> NPC;
        private System.Random random;

        private float timeRemaining = 0.0f;

        // Use this for initialization
        void Start()
        {
            spawnpoints = new List<GameObject>();
            NPC = new List<GameObject>();
            foreach (GameObject obj in GameObject.FindGameObjectsWithTag("SpawnPoint"))
                spawnpoints.Add(obj);
            random = new System.Random();
        }

        void Update()
        {
            if (timeRemaining <= 0)
            {
                if (NPC.Count < 20)
                    spawnNewNPC();
                timeRemaining = random.Next(0, 2);
            }
            timeRemaining -= Time.deltaTime;
        }

        private void spawnNewNPC()
        {
            int startValue = random.Next(0, spawnpoints.Count);
            int endValue = 0;
            bool selecting = true;
            while (selecting && spawnpoints.Count > 1)
            {
                endValue = random.Next(0, spawnpoints.Count);
                if (endValue != startValue)
                    selecting = false;
            }

            GeneratePath gp = new GeneratePath(spawnpoints[startValue].transform.position, spawnpoints[endValue].transform.position);
            List<Node> Path = gp.GetPath();
            if (Path != null)
            {
                GameObject newNPC = GameObject.Instantiate(npc);
                if (newNPC.GetComponent<NPCMovement>() == null)
                    newNPC.AddComponent<NPCMovement>();


                newNPC.GetComponent<NPCMovement>().InitPath(Path);
                NPC.Add(newNPC);
            }
                
        }

        public void KillNPC(GameObject obj)
        {
            NPC.Remove(obj);
            GameObject.Destroy(obj);
        }
    }
}


