﻿using UnityEngine;
using System.Collections.Generic;

namespace PathFinding
{
    public class Node
    {
        public int ID;
        public float posX, posZ;
        public List<Line> Connections;

        public bool enabled = true;

        public float DistanceTracker = -1;
        public Node connectedFrom = null;
        public int stepCount = -1;
        
        public Node(int ID, float x, float z)
        {
            this.ID = ID;
            posX = x;
            posZ = z;
            Connections = new List<Line>();
        }

        public void AddConnection(Line l)
        {
            if (!Connections.Contains(l))
                Connections.Add(l);
        }

        public override string ToString()
        {
            return "Node position - X: " + posX + ", Z: " + posZ;
        }


        public Vector3 Vector3(float height)
        {
            return new Vector3(posX, height, posZ);
        }

        public void disable()
        {
            foreach(Line l in Connections)
            {
                foreach(Line l2 in l.To.Connections)
                {
                    if (l2.To == this)
                    {
                        l.To.Connections.Remove(l2);
                        break;
                    }
                }
            }
            Connections.Clear();
            enabled = false;
        }
    }
}
