﻿using Assets._Scripts;
using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class CarController : MonoBehaviour, HasSituation {
    public delegate void Action();
    public float x, y, z = 0;
    private bool moving = false;
    private bool crashing = false;
    private Situation mySituation;

    private void Awake()
    {
        mySituation = new Assets._Scripts.Situation()
        {
            Action = DriveForward,
            Name = "CarStartMoving",
            SetOffTime = 5.0f,
            Fires = true
        };
    }
    // Use this for initialization
    void Start() {


    }
	
	// Update is called once per frame
	void Update () {
        if (moving)
        {
            transform.Translate(x * Time.deltaTime, y * Time.deltaTime, z * Time.deltaTime);
        }
        if (crashing && moving)
        {
            RollOut();
        }
	}
    public void DriveForward()
    {
        z = 10;
        moving = true;
    }

    public void RollOut()
    {
        x = x / 1.05f;
        y = y / 1.05f;
        z = z / 1.05f;
        if(Math.Abs(x) < 0.1 && Math.Abs(y) < 0.1 && Math.Abs(z) < 0.1)
        {
            x = 0;
            y = 0;
            z = 0;
            moving = false;
        }
    }

    private void OnCollisionEnter(Collision collision)
    {
        print(collision.collider.name);
        if (collision.collider.name == "Cat")
        {
            crashing = true;
        }else if(collision.collider.name == "Player")
        {
            SceneManager.LoadScene("GameOver");
        }
    }

    public Situation GetSituation()
    {
        return mySituation;
    }
}
