﻿using System.Collections.Generic;

namespace Assets._Scripts
{
    public class EventFactory
    {

        private EventController ec;

        public EventFactory(EventController ec)
        {
            this.ec = ec;
        }
        public Queue<Situation> CreateEvents()
        {
            Queue<Situation> result = new Queue<Situation>();
            List<Situation> allEvents = new List<Situation>();

            allEvents.Add(ec.Cat.GetSituation());
            allEvents.Add(ec.Car.GetSituation());
            //allEvents.Add(ec.Piano.GetSituation());
            //allEvents.Add(ec.Gma.GetSituation());
            allEvents.Add(ec.Door.GetSituation());
            allEvents.Add(ec.Boy.GetSituation());
            allEvents.Add(ec.Girl.GetSituation());
            allEvents.Sort((x, y) => x.SetOffTime.CompareTo(y.SetOffTime));
            foreach(Situation s in allEvents)
            {
                result.Enqueue(s);
            }
            return result;
        }
    }
}
